#include <stdio.h>
#include <stream.h>
#include "comm.h"

int ear;

void DoCmd (char command, Comm* pComm)
{
char comstr [MAXMESG];
char message [MAXMESG];
float x, y, direc;
int nummer;
char team [30];

	switch (command)
	{
		case 'v': 
			pComm->SendMessage ("(change_mode before_kick_off)\n");
			break;
		case 'a':
			pComm->SendMessage ("(change_mode kick_off)\n");
			break;
		case 'w':
			pComm->SendMessage ("(change_mode play_on)\n");
			break;
		case 'k':
			pComm->SendMessage ("(change_mode kick_in)\n");
			break;
		case 's':
			cout << "Teamname? >> "; cin >> team;
			cout << "Spielernummer? >> "; cin >> nummer;
			cout << "x? >> "; cin >> x;
			cout << "y? >> "; cin >> y;
			cout << "Richtung? >> "; cin >> direc;
			sprintf (comstr, "(move (player %s %i) %f %f %f)\n", team, nummer, x, y, direc);
			pComm->SendMessage (comstr);
			break;
		case 'b':
			cout << "x? >> "; cin >> x;
			cout << "y? >> "; cin >> y;
			cout << "Richtung? >> "; cin >> direc;
			sprintf (comstr, "(move (ball) %f %f %f)\n", x, y, direc);
			pComm->SendMessage (comstr);
			break;
		case 'i':	
			pComm->SendMessage ("(look)\n");
			break;
		case 'n':
			cout << "Nachricht? >> "; cin >> message;
			sprintf (comstr, "(say %s)\n", message);
			pComm->SendMessage (comstr);
			break;
		case 'p':
			pComm->SendMessage ("(check_ball)\n");
			break;
		case 'h':
			if (ear)
			{
				ear=0;
				pComm->SendMessage ("(ear off)\n");
			}
			else
			{
				ear=1;
				pComm->SendMessage ("(ear on)\n");
			}
			break;
		default:
			cout << "Unbekanntes Kommando!\n";
			break;			 
	}
}

void main (int argc, char* argv [])
{
char command;
char message [MAXMESG];
Comm communi (argv [1], 6001);
	communi.SetProtocol (0);

	ear=1;
	do
	{
		cout << '\n';
		cout << "SimpleCOACH\n\n";
		cout << "Spielmodus wechseln:\n";
		cout << "      vor dem Anstoss ................................ v\n";
		cout << "      Anstoss ........................................ a\n";
		cout << "      Weiterspielen .................................. w\n";
		cout << "      Abstoss ........................................ k\n";
		cout << '\n';
		cout << "Objekte bewegen:\n";
		cout << "      Spieler bewegen ................................ s\n";
		cout << "      Ball bewegen ................................... b\n";
		cout << '\n';
		cout << "Informationen sammeln ................................ i\n";
		cout << '\n';
		cout << "Nachricht an alle .................................... n\n";
		cout << '\n';
		cout << "Ballposition bestimmen ............................... p\n";
		cout << '\n';
		if (ear)
			cout << "Hinhoeren (Nein) ..................................... h\n";
		else
			cout << "Hinhoeren (Ja) ....................................... h\n";
		cout << '\n';
		cout << "Beenden .............................................. q\n";
		cout << "\n>> ";
	
		cin >> command;
		if (command != 'q')
		{
			DoCmd (command, &communi);
			communi.WaitForMessage (message, MAXMESG, 10, 0);
			sscanf (message, "%[^\n]", message);
		   cout << message << '\n';
		}
	}
	while (command != 'q');
}
